Firmware2/buildroot/share/git/mfpr

38 lines
1003 B
Plaintext
Raw Normal View History

#!/usr/bin/env bash
#
2021-11-03 13:02:21 +01:00
# mfpr [1|2]
#
2021-11-03 13:02:21 +01:00
# Make a PR targeted to MarlinFirmware/[repo]
#
2021-11-03 13:02:21 +01:00
[[ $# < 2 && $1 != "-h" && $1 != "--help" ]] || { echo "usage: `basename $0` [1|2] [branch]" 1>&2 ; exit 1; }
2017-07-03 03:43:57 +02:00
MFINFO=$(mfinfo "$@") || exit 1
IFS=' ' read -a INFO <<< "$MFINFO"
ORG=${INFO[0]}
FORK=${INFO[1]}
REPO=${INFO[2]}
TARG=${INFO[3]}
BRANCH=${INFO[4]}
2017-07-03 03:43:57 +02:00
OLDBRANCH=${INFO[5]}
2017-07-03 03:43:57 +02:00
[[ $BRANCH == $TARG ]] && { echo "Can't create a PR from the PR Target ($BRANCH). Make a copy first." 1>&2 ; exit 1; }
2017-07-03 03:43:57 +02:00
[[ $BRANCH != $OLDBRANCH ]] && { git checkout $BRANCH || exit 1; }
2017-07-03 03:43:57 +02:00
# See if it's been pushed yet
if [ -z "$(git branch -vv | grep ^\* | grep \\[origin)" ]; then firstpush; fi
2020-04-24 04:53:28 +02:00
OPEN=$(echo $(which gnome-open xdg-open open) | awk '{ print $1 }')
URL="https://github.com/$ORG/$REPO/compare/$TARG...$FORK:$BRANCH?expand=1"
2019-10-02 05:03:59 +02:00
if [ -z "$OPEN" ]; then
echo "Can't find a tool to open the URL:"
echo $URL
else
echo "Opening a New PR Form..."
2019-10-02 05:03:59 +02:00
"$OPEN" "$URL"
fi
2017-07-03 03:43:57 +02:00
[[ $BRANCH != $OLDBRANCH ]] && git checkout $OLDBRANCH